/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export class VSDataTransfer {
    constructor() {
        this._data = new Map();
    }
    get size() {
        return this._data.size;
    }
    has(mimeType) {
        return this._data.has(mimeType);
    }
    get(mimeType) {
        return this._data.get(mimeType);
    }
    set(mimeType, value) {
        this._data.set(mimeType, value);
    }
    setString(mimeType, stringOrPromise) {
        this.set(mimeType, {
            asString: () => __awaiter(this, void 0, void 0, function* () { return stringOrPromise; }),
            asFile: () => undefined,
            value: typeof stringOrPromise === 'string' ? stringOrPromise : undefined,
        });
    }
    setFile(mimeType, fileName, uri, data) {
        this.set(mimeType, {
            asString: () => __awaiter(this, void 0, void 0, function* () { return ''; }),
            asFile: () => ({ name: fileName, uri, data }),
            value: undefined,
        });
    }
}
